*===========================================================================
* TSColumn.PRG Version 6.0 5/Apr/2002
*===========================================================================

#define _DDE_CH
#define _DLL_CH
#define _VIDEO_CH

#include "Fivewin.ch"
#include "TSBrowse.ch"

CLASS TSColumn

	CLASSDATA aProperties INIT { "cHeading", "cPicture", "nWidth" }
   CLASSDATA aEvents     INIT { "OnEdit" }

   DATA aExport     AS ARRAY                     // Array for creating Excel Worksheets (requires ClipWks)
   DATA aList       AS ARRAY                     // activates combobox on editing
   DATA bPrevEdit   AS CODEBLOCK INIT NIL        // Action to be performed before editing cell
   DATA bPostEdit   AS CODEBLOCK INIT NIL        // Action to be performed after editing cell
   DATA bData       AS CODEBLOCK                 // Mandatory code block to return column data
   DATA bDown       AS CODEBLOCK INIT NIL        // Editing optional spinner bDown movement
   DATA bAction     AS CODEBLOCK INIT NIL        // TBtnGet action
   DATA bHAction    AS CODEBLOCK INIT NIL        // header action on click
   DATA bMax        AS CODEBLOCK INIT NIL        // Editing optional spinner bMax value
   DATA bMin        AS CODEBLOCK INIT NIL        // Editing optional spinner bMin value
   DATA bUp         AS CODEBLOCK INIT NIL        // Editing optional spinner bUp movement
   DATA bValid      AS CODEBLOCK                 // Editing valid block
   DATA bWhen       AS CODEBLOCK INIT NIL        // Editing when block
	DATA Cargo
   DATA cData
   DATA cError                                   // Bad valid error message
   DATA cFooting                                 // Optional Footing text
   DATA cHeading                                 // Optional Header text
   DATA cMsg                                     // Editing message
   DATA cOrder                                   // index tag name
   DATA cPicture                                 // Optional picture clause
   DATA cResName                                 // TBtnGet bitmap resource name
   DATA oFont       // AS OBJECT                    // cells font
   DATA oFontHead   // AS OBJECT                    // header font
   DATA oFontFoot   // AS OBJECT                    // footer font
   DATA l3DLook     AS LOGICAL                   // 3D Look for cells
   DATA l3DLookHead AS LOGICAL                   // 3D Look for header
   DATA l3DLookFoot AS LOGICAL                   // 3D Look for footer
   DATA l3DTextCell, l3DTextHead, l3DTextFoot    // 3d Text
   DATA lAppend     AS LOGICAL                   // True if appending is allowable (only meaningfull if ::lEdit is true)
   DATA lBitMap                                  // Optional bmp flag
   DATA lAdjBmp     AS LOGICAL INIT .F.          // Stretch optional bitmap
   DATA lAdjBmpHead AS LOGICAL INIT .F.          // Stretch optional header bitmap
   DATA lAdjBmpFoot AS LOGICAL INIT .F.          // Stretch optional header bitmap
   DATA lChildHead  AS LOGICAL                   // Double Header Flag
   DATA lEdit       AS LOGICAL                   // True if editing is allowable
   DATA lFixLite    AS LOGICAL                   // Fixed cursor
   DATA lIndexCol   AS LOGICAL                   // index flag to UpStable when data is changed 
   DATA lNoLite     AS LOGICAL                   // True to skip cell during SelectlLine()
   DATA lNoHiLite   AS LOGICAL                   // True to skip cell during SelectlLine()
   DATA lSpinner    AS LOGICAL                   // Editing optional spinner (only Numerics and Dates - others will be ignored)
   DATA nAlign                                   // Optional Alignement for cell's text
   DATA nBmpWidth   AS NUMERIC                   // TBtnGet bitmap width
   DATA nClrFore, nClrBack                       // cell colors
   DATA nClrHeadBack, nClrHeadFore               // headers colors
   DATA nClrFocuBack, nClrFocuFore               // focused cell colors
   DATA nClrEditBack, nClrEditFore               // editing cell colors
   DATA nClrFootBack, nClrFootFore               // footers colors
   DATA nClrSeleBack, nClrSeleFore               // Focused inactive colors
   DATA nClrOrdeBack, nClrOrdeFore               // order control column colors
   DATA nClr3DLCell, nClr3DLHead, nClr3DLFoot    // light color for 3d text
   DATA nClr3DSCell, nClr3DSHead, nClr3DSFoot    // shadow color for 3d text
   DATA nEditMove   AS NUMERIC                   // post editing cursor movement
   DATA nFAlign                                  // Optional Alignement for footer's text
   DATA nHAlign                                  // Optional Alignement for header's text
   DATA nWidth      AS NUMERIC                   // Optional Width
   DATA OnEdit                                   // Visual FiveWin 2.0

   METHOD New( cHeading, bData, cPicture, aColors, aAlign, nWidth, ;
               lBitMap, lEdit, bValid, lNoLite, cOrder, ;
               cFooting, bPrevEdit, bPostEdit, nEditMove, lFixLite, ;
               a3DLook, bWhen, oBrw, lSpinner, bUp, bDown, bMin, bMax, ;
               lAppend, cMsg, cError ) CONSTRUCTOR

	METHOD End() VIRTUAL                          // Visual FiveWin 2.0

	METHOD Load( cInfo )
	METHOD Save()                                 // Visual FiveWin 2.0

ENDCLASS

*=============================================================================
* METHOD TSColumn:New() Version 6.0 5/Apr/2002
*=============================================================================

METHOD New( cHeading, bData, cPicture, aColors, aAlign, nWidth, ;
            lBitMap, lEdit, bValid, lNoLite, cOrder, cFooting, ;
            bPrevEdit, bPostEdit, nEditMove, lFixLite, a3DLook, ;
            bWhen, oBrw, lSpinner, bUp, bDown, bMin, bMax, lAppend, ;
            cMsg, cError ) CLASS TSColumn

   Local nEle, uAlign, xVar, ;
         aTmpColor := Array( 14 ) , ;
         aTmp3D    := Array( 3 ), ;
         aTmpAlign := Array( 3 )

   If aColors != Nil
      Aeval( aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   Endif

   If a3DLook != Nil
      Aeval( a3DLook, { | l3D, nEle | aTmp3D[ nEle ] := l3D } )
   Endif

   If aAlign != Nil
      Aeval( aAlign, { | nAli, nEle | ;
                       aTmpAlign[ nEle ] := If( ValType( nAli ) == "N" .or. ;
                       ValType( nAli ) == "B", nAli, ;
                       If( ( xVar := AScan( { "LEFT", "CENTER", "RIGHT", "VERT" }, ;
                           Upper( nAli ) ) ) > 0, xVar - 1, xVar ) ) } )
   Endif

   If cMsg == Nil
      #ifdef _SPANISH_
         cMsg := "Para cancelar la edicin, presiona [Esc]"
      #else
         cMsg := "Press [Esc] to cancel editing"
      #endif
   Endif

	DEFAULT cHeading  := ""            , ;
			  bData     := {|| Nil }     , ;
			  cPicture  := nil           , ;
			  lBitMap   := .F.           , ;
			  lEdit     := .F.           , ;
           lNoLite := .F.           , ;
			  cOrder    := ""            , ;
			  bValid    := {|| .T. }     , ;
           nEditMove := DT_MOVE_RIGHT , ;        // movement after editing
			  lFixLite  := .F.           , ;        // for "double cursor" (permanent) efect (only when oTCB:lCellBrw == .T.)
           lSpinner  := .F.           , ;
           lAppend   := .T.
                  
   If oBrw == Nil
      Default aTmpColor[ 1 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrText
              aTmpColor[ 2 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrPane
              aTmpColor[ 3 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrHeadFore
              aTmpColor[ 4 ]  := GetSysColor( COLOR_BTNFACE )   , ; // nClrHeadBack
              aTmpColor[ 5 ]  := GetSysColor( COLOR_HIGHLIGHTTEXT ), ; // nClrFocuFore
              aTmpColor[ 6 ]  := GetSysColor( COLOR_HIGHLIGHT )     // nClrFocuBack

      Default aTmpColor[ 7 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrEditFore
              aTmpColor[ 8 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrEditBack
              aTmpColor[ 9 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrFootFore
              aTmpColor[ 10 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrFootBack
              aTmpColor[ 11 ] := CLR_HGRAY                      , ; // nClrSeleFore  NO focused
              aTmpColor[ 12 ] := CLR_GRAY                       , ; // nClrSeleBack  NO focused
              aTmpColor[ 13 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrOrdeFore
              aTmpColor[ 14 ] := GetSysColor( COLOR_BTNFACE )       // nClrOrdeBack
   Else
      Default aTmpColor[ 1 ]  := oBrw:nClrText, ;
              aTmpColor[ 2 ]  := oBrw:nClrPane, ;
              aTmpColor[ 3 ]  := oBrw:nClrHeadFore, ;
              aTmpColor[ 4 ]  := oBrw:nClrHeadBack, ;
              aTmpColor[ 5 ]  := oBrw:nClrFocuFore, ;
              aTmpColor[ 6 ]  := oBrw:nClrFocuBack

      Default aTmpColor[ 7 ]  := oBrw:nClrEditFore, ;
              aTmpColor[ 8 ]  := oBrw:nClrEditBack, ;
              aTmpColor[ 9 ]  := oBrw:nClrFootFore, ;
              aTmpColor[ 10 ] := oBrw:nClrFootBack, ;
              aTmpColor[ 11 ] := oBrw:nClrSeleFore, ;
              aTmpColor[ 12 ] := oBrw:nClrSeleBack, ;
              aTmpColor[ 13 ] := oBrw:nClrOrdeFore, ;
              aTmpColor[ 14 ] := oBrw:nClrOrdeBack

      ::oFont     = oBrw:oFont
      ::oFontHead = oBrw:oFont
      ::oFontFoot = oBrw:oFont
   EndIf

   Default aTmp3D[ 1 ]     := .F.
   Default aTmp3D[ 2 ]     := aTmp3D[ 1 ], ;
           aTmp3D[ 3 ]     := aTmp3D[ 1 ]

   Default aTmpAlign[ 1 ]  := DT_LEFT
   Default aTmpAlign[ 2 ]  := aTmpAlign[ 1 ], ;
           aTmpAlign[ 3 ]  := aTmpAlign[ 1 ]

   For nEle := 1 TO 3
      If ValType( aTmpAlign[ nEle ] ) == "C"
         uAlign := AScan( { "LEFT", "CENTER", "RIGHT" }, ;
                          {| c |  Upper( aTmpAlign[ nEle ] ) $ c } ) - 1

         uAlign := If( uAlign < 0, DT_LEFT, uAlign )
         aTmpAlign[ nEle ] := uAlign
      Endif
   Next

   For nEle := 1 TO 3
      If ValType( aTmp3D[ nEle ] ) == "C"
         uAlign := AScan( {"T",".T.","SI","YES"}, ;
                          {| c |  Upper( aTmp3D[ nEle ] ) == c } )
         aTmp3D[ nEle ] := If( uAlign > 0, .T., .F. )
      Endif
   Next

   If ValType( Eval( bdata ) ) == "A"
      ::bData := Eval( bData )[ 1 ]
      ::aList := Eval( bData )[ 2 ]
   Else
      ::bData := bData
   Endif

   If nWidth == Nil
      If oBrw != Nil
         nWidth := SBGetHeight( oBrw:hWnd, oBrw:oFont:hFont, 1 )
         nEle   := Max( If( aTmpAlign[ 2 ] == 3, 2, Len( cHeading ) ), ;
                   Len( If( Empty( cPicture ), cValToChar( Eval( ::bData ) ), ;
                   Transform( cValToChar( Eval( ::bData ) ), cPicture ) ) ) )
         nWidth := Round( nWidth * nEle * 1.3, 0 )
      Else
         nWidth := Int( If( ! lBitMap , 0.67 * ;
                   GetTextWidth( 0, Replicate( "B", ;
                   Max( Len( cHeading ), Len( If( Empty( cPicture ), ;
                   cValToChar( Eval( bData ) ), ;
                   Transform( cValToChar( Eval( bData ) ), cPicture ) ) ) ) + ;
                   1 ), 0 ), 16 ) )
      EndIf
	Endif

   ::cOrder       := cOrder
   ::cHeading     := cHeading
   ::cFooting     := cFooting
   ::cPicture     := cPicture
   ::nAlign       := aTmpAlign[ 1 ]
   ::nHAlign      := aTmpAlign[ 2 ]
   ::nFAlign      := aTmpAlign[ 3 ]
   ::nWidth       := nWidth
   ::lBitMap      := lBitMap
   ::lEdit        := lEdit
   ::lNoLite      := lNoLite
   ::lNoHilite    := lNoLite
   ::cMsg         := cMsg
   ::bValid       := bValid
   ::cError       := ""
   ::bPrevEdit    := bPrevEdit
   ::bPostEdit    := bPostEdit
   ::nEditMove    := nEditMove
   ::lFixLite     := lFixLite
   ::l3DLook      := aTmp3D[ 1 ]
   ::l3DLookHead  := aTmp3D[ 2 ]
   ::l3DLookFoot  := aTmp3D[ 3 ]
   ::bWhen        := bWhen
   ::aExport      := {}
   ::lSpinner     := lSpinner
   ::bUp          := bUp
   ::bDown        := bDown
   ::bMin         := bMin
   ::bMax         := bMax
   ::lAppend      := lAppend
   ::nClrFore     := aTmpColor[ 1 ]
   ::nClrBack     := aTmpColor[ 2 ]
   ::nClrHeadFore := aTmpColor[ 3 ]
   ::nClrHeadBack := aTmpColor[ 4 ]
   ::nClrFocuFore := aTmpColor[ 5 ]
   ::nClrFocuBack := aTmpColor[ 6 ]
   ::nClrEditFore := aTmpColor[ 7 ]
   ::nClrEditBack := aTmpColor[ 8 ]
   ::nClrFootFore := aTmpColor[ 9 ]
   ::nClrFootBack := aTmpColor[ 10 ]
   ::nClrSeleFore := aTmpColor[ 11 ]
   ::nClrSeleBack := aTmpColor[ 12 ]
   ::nClrOrdeFore := aTmpColor[ 13 ]
   ::nClrOrdeBack := aTmpColor[ 14 ]
   ::nClr3DLCell  := GetSysColor( COLOR_BTNHIGHLIGHT )
   ::nClr3DLHead  := GetSysColor( COLOR_BTNHIGHLIGHT )
   ::nClr3DLFoot  := GetSysColor( COLOR_BTNHIGHLIGHT )
   ::nClr3DSCell  := GetSysColor( COLOR_BTNSHADOW )
   ::nClr3DSHead  := GetSysColor( COLOR_BTNSHADOW )
   ::nClr3DSFoot  := GetSysColor( COLOR_BTNSHADOW )
   ::lIndexCol    := .F.
   ::lAdjBmp      := .F.
   ::lAdjBmpHead  := .F.
   ::lAdjBmpFoot  := .F.

Return Self

*=============================================================================
* METHOD TSColumn:Load() Version 6.0 5/Apr/2002
*=============================================================================

METHOD Load( cInfo ) CLASS TSColumn

   local nPos := 1, nProps, n, nLen
   local cData, cType, cBuffer

   nProps := Bin2I( SubStr( cInfo, nPos, 2 ) )
   nPos += 2

   for n := 1 to nProps
      nLen  := Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cData := SubStr( cInfo, nPos, nLen )
      nPos += nLen
      cType := SubStr( cInfo, nPos++, 1 )
      nLen  := Bin2I( SubStr( cInfo, nPos, 2 ) )
      nPos += 2
      cBuffer := SubStr( cInfo, nPos, nLen )
      nPos += nLen
      do case
         case cType == "A"
              OSend( Self, "_" + cData, ARead( cBuffer ) )

         case cType == "O"
              OSend( Self, "_" + cData, ORead( cBuffer ) )

         case cType == "C"
              OSend( Self, "_" + cData, cBuffer )

         case cType == "L"
              OSend( Self, "_" + cData, cBuffer == ".T." )

         case cType == "N"
              OSend( Self, "_" + cData, Val( cBuffer ) )
      endcase
   next

Return Nil

*=============================================================================
* METHOD TSColumn:Save() Version 6.0 5/Apr/2002
*=============================================================================

METHOD Save() CLASS TSColumn

   Local n, cType, cMethod, uData, ;
         cInfo := "", ;
         oWnd  := &( ::ClassName() + "()" ), ;
         nProps := 0

   oWnd:New()

   For n := 1 to Len( ::aProperties )
      If ! ( uData := OSend( Self, ::aProperties[ n ] ) ) == ;
         OSend( oWnd, ::aProperties[ n ] )
         cInfo += ( I2Bin( Len( ::aProperties[ n ] ) ) + ;
                    ::aProperties[ n ] )
         nProps++
         cType := ValType( uData )
         Do Case
            Case cType == "A"
                 cInfo += ASave( uData )

            Case cType == "O"
                 cInfo += uData:Save()

            Otherwise
                 cInfo += ( cType + I2Bin( Len( uData := cValToChar( uData ) ) ) + ;
                             uData )
         Endcase
      Endif
   Next

   If ::aEvents != nil
      For n := 1 to Len( ::aEvents )
         If ( cMethod := OSend( Self, ::aEvents[ n ] ) ) != nil
            cInfo += ( I2Bin( Len( ::aEvents[ n ] ) ) + ;
                       ::aEvents[ n ] )
            nProps++
            cInfo += ( "C" + I2Bin( Len( cMethod ) ) + cMethod )
         Endif
      Next
   Endif

   oWnd:End()

Return "O" + I2Bin( 2 + Len( ::ClassName() ) + 2 + Len( cInfo ) ) + ;
       I2Bin( Len( ::ClassName() ) ) + ::ClassName() + I2Bin( nProps ) + cInfo
