#include "FiveWin.ch"

#ifdef __XPP__
   #define COMBO_BASE      320
#else
   #define COMBO_BASE  WM_USER
#endif

#define CB_SETEDITSEL    ( COMBO_BASE +  2 )
#define CB_GETCURSEL     ( COMBO_BASE +  7 )
#define CB_SETCURSEL     ( COMBO_BASE + 14 )
#define CB_SHOWDROPDOWN  ( COMBO_BASE + 15 )
#define CB_ERR              -1

* ============================================================================
* CLASS TSCombo  Version 6.0 Apr/5/2002
* ============================================================================

CLASS TSCombo FROM TComboBox

   METHOD Change()
   METHOD GetDlgCode( nLastKey )
   METHOD KeyDown( nKey, nFlags )
   METHOD KeyChar( nKey, nFlags )
   METHOD LButtonDown( nRow, nCol )
   METHOD LostFocus()

ENDCLASS

* ============================================================================
* METHOD TSCombo:Change() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Change() CLASS TSCombo

   Local cItem := GetWindowText( ::hWnd ) // Current Value

   ::nAt = ::SendMsg( CB_GETCURSEL ) + 1

   If ::nAt != 0 .and. ::nAt <= Len( ::aItems )
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      Else
         Eval( ::bSetGet, ::aItems[ ::nAt ] )
      EndIf
   EndIf

   If ::oGet != Nil                        // Always not nil for dropdown
      ::oGet:VarPut( Eval( ::bSetGet ) )   // udate variable before calling bChange
      ::oGet:Refresh()
   EndIf

   If ::bChange != nil
      Eval( ::bChange, Self, cItem )
   Endif

   ::nLastKey := 0

Return Nil

* ============================================================================
* METHOD TSCombo:GetDlgCode() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GetDlgCode( nLastKey, nFlags ) CLASS TSCombo


Return  DLGC_WANTALLKEYS

* ============================================================================
* METHOD TSCombo:KeyDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSCombo

   ::nLastKey := nKey

   If nKey == VK_TAB .or. nKey == VK_RETURN .or. nKey == VK_ESCAPE
      Eval( ::bKeyDown, nKey )
      Return 0
   Endif

Return Nil

* ============================================================================
* METHOD TSCombo:LButtonDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LButtonDown( nRow, nCol ) CLASS TSCombo

   Local nShow := 1

   If ::nLastKey != Nil .and. ::nLastKey == 9999
      nShow := 0
      ::nLastKey := 0
   Else
      ::nLastKey := 9999
   EndIf

   ::PostMsg( CB_SHOWDROPDOWN, nShow, 0 )

Return 0

* ============================================================================
* METHOD TSCombo:LostFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LostFocus() CLASS TSCombo

   Local nAt

   nAt := ::SendMsg( CB_GETCURSEL )

   If nAt != CB_ERR
      ::nAt = nAt + 1
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, nAt + 1 )
      Else
         Eval( ::bSetGet, ::aItems[ nAt + 1 ] )
      Endif
   Else
      Eval( ::bSetGet, GetWindowText( ::hWnd ) )
   Endif

   SysRefresh()

   If ::nLastKey != Nil .and. ::nLastKey == 9999
      ::nLastKey := 0
      ::SetFocus()
      ::SendMsg( CB_SETEDITSEL, 0, nMakeLong( 0, -1 ) )
   Else
      ::SendMsg( CB_SHOWDROPDOWN, 0, 0 )
      Eval( ::bKeyDown, VK_ESCAPE )
      ::oWnd:GoNextCtrl( ::hWnd )
   EndIf


Return Nil

* ============================================================================
* METHOD TSCombo:KeyChar() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSCombo

   Local nDefValue, nDefButton, hDef

   Do Case
      Case nKey == VK_TAB .and. GetKeyState( VK_SHIFT )
         return 0    // We don't want API default behavior

      Case nKey == VK_TAB
         return 0    // We don't want API default behavior

      Case nKey == VK_ESCAPE
         return 0

      Case nKey == VK_RETURN
         Return 0

      Otherwise
         Return Super:Keychar( nKey, nFlags ) 
   Endcase

Return 0

