#define _VIDEO_CH
#define _DDE_CH

#include "FiveWin.ch"
#include "TSBrowse.ch"

#define VK_CTRL_W          23
#define WM_NCLBUTTONDOWN  161  // 0x00A1
#define WM_NCHITTEST      132  // 0x0084
#define HTERROR           (-2)
#define WM_SETCURSOR       32  // 0x0020

Static nsLastKey

* ============================================================================
* CLASS TSGet  Version 6.0 Apr/5/2002
* ============================================================================

CLASS TSGet FROM TGet

   DATA lRightLeftExit AS LOGICAL INIT .F.
   DATA lFixCaret

   METHOD GetDlgCode( nLastKey )
   METHOD GotFocus()
   METHOD _GotFocus( hCtlLost )
   METHOD KeyDown(nKey,nFlags)
   METHOD KeyChar(nKey,nFlags)
   METHOD HandleEvent( nMsg, nWParam, nLParam )
   METHOD LostFocus( hCtlFocus )
   METHOD lValid()
   METHOD RButtonDown( nRow, nCol, nFlags )
   METHOD Spinner( bUp, bDown, bMin, bMax )

ENDCLASS

* ============================================================================
* METHOD TSGet:GetDlgCode() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GetDlgCode( nLastKey, nFlags ) CLASS TSGet

   ::oWnd:nLastkey := ::oWnd:oWnd:nLastKey := nLastKey

Return DLGC_WANTALLKEYS

* ============================================================================
* METHOD TSGet:GotFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GotFocus() CLASS TSGet

   If ! ::lDrag
      ::oGet:KillFocus()   // to properly initialize internal status
      ::oGet:SetFocus()
      ::DispText()
      ::oGet:Pos = ::nPos
      ::SetPos( ::nPos )
      CallWindowProc( ::nOldProc, ::hWnd, WM_SETFOCUS )

      If ::lFixCaret != Nil .and. ::lFixCaret
         DestroyCaret()
         CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         ShowCaret( ::hWnd )
      Else
         DestroyCaret()
         If Set( _SET_INSERT )
            CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         Else
            CreateCaret( ::hWnd, 0, 2, ::nGetChrHeight() )
         EndIf
         ShowCaret( ::hWnd )
      Endif

   Else
      HideCaret( ::hWnd )
   Endif

   ::nLastKey := nsLastKey := 0
   ::_GotFocus()

Return 0

* ============================================================================
* METHOD TSGet:_GotFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD _GotFocus( hCtlLost ) CLASS TSGet

   ::lFocused       = .T.
   ::oWnd:nResult   = Self
   ::oWnd:oCtlFocus = Self
   ::oWnd:hCtlFocus = ::hWnd
   ::SetMsg( ::cMsg )

   If ::lDrag
      ::ShowDots()
   Endif

   If ::bGotFocus != nil
      Return Eval( ::bGotFocus, Self, hCtlLost )
   Endif

Return Nil

* ============================================================================
* METHOD TSGet:KeyDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSGet

   ::nLastKey := nsLastKey := ::oWnd:oWnd:nLastKey := nKey

   IF nKey = VK_DOWN .OR. nKey = VK_UP .OR. nKey = VK_RETURN .OR.;
      (::lRightLeftExit .AND. (nKey = VK_LEFT .OR. nKey = VK_RIGHT))

      If ::lValid()

         ::oWnd:GoPrevCtrl( ::hWnd )

         If ::bKeyDown != Nil
            Eval( ::bKeyDown, nKey, nFlags)
         Endif

         Return 0

      Else
         nsLastKey := 0
         ::DispText()
         ::oGet:Pos = ::nPos
      Endif

      Return Nil

   Elseif nKey == VK_INSERT .and. ! GetKeyState( VK_SHIFT ) .and. ;
          ! GetKeyState( VK_CONTROL )

      Set( _SET_INSERT, ! Set( _SET_INSERT ) )

      If ::lFixCaret == Nil .or. ! ::lFixCaret
         DestroyCaret()
         If Set( _SET_INSERT )
            CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         Else
            CreateCaret( ::hWnd, 0, 2, ::nGetChrHeight() )
         EndIf
         ShowCaret( ::hWnd )
      EndIf

      Return 0

   Endif

RETURN Super:KeyDown( nKey, nFlags )

* ============================================================================
* METHOD TSGet:KeyChar() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSGet

   Local nHi, nLo
   Local lAccept
   Local bKeyAction := SetKey( nKey )
   Local nDefButton

   ::nLastKey := nsLastKey := nKey

   If bKeyAction != nil .and. lAnd( nFlags, 16777216 ) // function Key
      Eval( bKeyAction, ProcName( 4 ), ProcLine( 4 ), Self )
      return 0         // Already processed, API do nothing
   EndIf

   If ::lReadOnly
      If nKey == VK_ESCAPE
         ::oWnd:End()
      EndIf
      Return 0
   EndIf

   Do Case
      Case nKey == VK_BACK       // Already processed at KeyDown
           Return 0

      Case nKey == VK_TAB .and. GetKeyState( VK_SHIFT )
           Return 0

      Case nKey == VK_TAB .or. nKey == VK_RETURN
           Return 0

      Case nKey >= 32 .and. nKey < 256
           ::GetSelPos( @nLo, @nHi )
           // Delete selection
           If nHi != nLo
              ::GetDelSel( nLo, nHi )
              ::EditUpdate()
           EndIf
           If ::oGet:Type == "N" .and. ;
              ( Chr( nKey ) == "." .or. Chr( nKey ) == "," )
              ::oGet:ToDecPos()
           Else
              If ::bChange != nil
                 lAccept = Eval( ::bChange, nKey, nFlags, Self )
                 If ValType( lAccept ) == "L" .and. ! lAccept
                    return 0
                 EndIf
              EndIf
              If Set( _SET_INSERT )             // many thanks to HMP
                 ::oGet:Insert( Chr( nKey ) )
              Else
                 ::oGet:Overstrike( Chr(nKey) )
              End
           EndIf
           If ::oGet:Rejected()
              MessageBeep( -1 )
           Else
              ::EditUpdate()
           EndIf

   EndCase

Return 0

* ============================================================================
* METHOD TSGet:LostFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSGet

   If ! ( nsLastKey == VK_RETURN .or.nsLastKey == VK_DOWN .or. ;
          nsLastKey == VK_RIGHT .or. nsLastKey == VK_UP .or. ;
          nsLastKey == VK_RETURN .or. nsLastKey == VK_LEFT )

      ::nLastKey := VK_ESCAPE
      ::SendMsg( WM_KEYDOWN, VK_ESCAPE )
      Return Nil

   EndIf

   ::SetMsg()
   ::oGet:SetFocus()

   If ! ::oGet:BadDate .and. ! ::lReadOnly .and. ;
      ( ::oGet:changed .or. ::oGet:unTransform() <> ::oGet:original )
      ::oGet:Assign()     // for adjust numbers
      ::oGet:UpdateBuffer()
   EndIf

   ::DispText()

   If ! ::oGet:BadDate
      ::oGet:KillFocus()
   Else
      ::oGet:Pos = 1
   EndIf

Return Nil

* ============================================================================
* METHOD TSGet:lValid() Version 6.0 Apr/5/2002
* ============================================================================

METHOD lValid() CLASS TSGet

   Local lRet := .T.

   ::oGet:Assign()
   ::oGet:UpdateBuffer()

   If ::oGet:BadDate
      Tone( 100, 3 )
      Return .F.
   Else
      If ValType( ::bValid ) == "B"
         lRet := Eval( ::bValid, ::Value()  )
      EndIf
   EndIf

Return lRet

* ============================================================================
* METHOD TSGet:RButtonDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD RButtonDown( nRow, nCol, nFlags ) CLASS TSGet

   Local oMenu, oClp, nLo, nHi, aMsg

   #ifdef _SPANISH_
      aMsg := { "&Deshacer","Cor&tar","&Copiar","&Pegar","&Borrar", ;
                "&Seleccionar Todo" }
   #else
      aMsg := { "&Undo","Cu&t","&Copy","&Paste","&Delete", ;
                "Select &All" }
   #EndIf

   ::GetSelPos( @nLo, @nHi )

   If GetFocus() != ::hWnd
      ::SetFocus()
      SysRefresh()
      If GetFocus() != ::hWnd
         Return Nil
      EndIf
   EndIf

   DEFINE CLIPBOARD oClp OF Self FORMAT TEXT

   If ::bRClicked != nil
      Return Eval( ::bRClicked, nRow, nCol, nFlags )
   EndIf

   MENU oMenu POPUP
      If ::lReadOnly .or. ::GetText() == cValToChar( ::oGet:Original )
         MENUITEM aMsg[ 1 ] ACTION ::UnDo() disabled
      Else
         MENUITEM aMsg[ 1 ] ACTION ::UnDo()
      EndIf

      SEPARATOR

      If ::lReadOnly .or. nLo == nHi
         MENUITEM aMsg[ 2 ]  ACTION ::Cut() disabled
      Else
         MENUITEM aMsg[ 2 ]  ACTION ::Cut()
      EndIf

      If nLo != nHi
         MENUITEM aMsg[ 3 ] ACTION ::Copy()
      Else
         MENUITEM aMsg[ 3 ] ACTION ::Copy() disabled
      EndIf

      If ! Empty( oClp:GetText() ) .and. !::lReadOnly
         MENUITEM aMsg[ 4 ] ACTION ::Paste()
      Else
         MENUITEM aMsg[ 4 ] ACTION ::Paste() DISABLED
      EndIf

      If ::lReadOnly .or. nLo == nHi
         MENUITEM aMsg[ 5 ] action nil disabled
      Else
         MENUITEM aMsg[ 5 ] ACTION If( nHi != nLo,;
                ( ::GetDelSel( nLo, nHi ), ::EditUpdate() ),)
      EndIf

      SEPARATOR
      MENUITEM aMsg[ 6 ] ACTION ::SelectAll()
   ENDMENU

   ACTIVATE POPUP oMenu AT nRow - 60, nCol OF Self

Return 0

* ============================================================================
* METHOD TSGet:Spinner() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Spinner( bUp, bDown, bMin, bMax ) CLASS TSGet

   ::bMin := bMin
   ::bMax := bMax
   ::nRight -= 20

   DEFINE SCROLLBAR ::oVScroll VERTICAL OF Self

   DEFAULT bUp   := {|| Self++ } ,;
           bDown := {|| Self-- }

   ::oVScroll:bGoUp   := {|| If( GetFocus() != ::hWnd, ::SetFocus(), Nil ), ;
                             Eval( bUp, Self ) }
   ::oVScroll:bGoDown := {|| If( GetFocus() != ::hWnd, ::SetFocus(), Nil ), ;
                             Eval( bDown, Self ) }

Return Nil

* ============================================================================
* METHOD TSBtnGet:HandleEvent() Version 6.0 Apr/5/2002
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSGet
// just used for some testings

Return Super:HandleEvent( nMsg, nWParam, nLParam )

